SystemOrganization addCategory: #'SOUL-Absinthe'!

SoulEvaluator subclass: #AbsintheEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheEvaluator class methodsFor: 'configuration' stamp: 'AndyKellens 11/8/2011 11:35'!
associatedFactory
	^AbsintheFactory! !

AnnotatedTerm subclass: #AbsintheAnnotatedTerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheAnnotatedTerm methodsFor: 'resolving' stamp: 'AndyKellens 11/8/2011 11:26'!
resolveIn: env startAt: anIndex
	| resolver |
	resolver := term resolveIn: env startAt: anIndex.
	resolver clause: self.
	^resolver! !

!MLI class methodsFor: '*SOUL-Absinthe' stamp: 'AndyKellens 11/8/2011 11:27'!
forEvolution
	^ self getMLIFor: #Evolution! !

MLI subclass: #MLIForAbsinthe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!MLIForAbsinthe class methodsFor: 'instance creation' stamp: 'AndyKellens 11/8/2011 11:21'!
register 
	self setAsMLIFor:#Evolution! !

!MLIForAbsinthe methodsFor: 'versions' stamp: 'ReinoutStevens 1/16/2012 14:51'!
mostRecentVersion 
	^RGHistoryRepository current snapshots last! !

!MLIForAbsinthe methodsFor: 'versions' stamp: 'ReinoutStevens 1/16/2012 14:51'!
oldestVersion
	^RGHistoryRepository current snapshots first! !

!MLIForAbsinthe methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:23'!
versions
	^RGHistoryRepository current snapshots! !

SMarkRunner subclass: #AbsintheRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheRunner class methodsFor: 'defaults' stamp: 'ReinoutStevens 1/18/2012 15:22'!
defaultTimer
	^AbsintheTimer ! !

!AbsintheRunner methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/19/2012 12:39'!
initialize
	super initialize.
	problemSize := 5.! !

Environment subclass: #AbsintheEnvironment
	instanceVariableNames: 'versionArray currentPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheEnvironment methodsFor: 'paths' stamp: 'AndyKellens 11/8/2011 11:31'!
currentPath
	| path |
	path := currentPath at: variableRollbackIndex.
	^path! !

!AbsintheEnvironment methodsFor: 'versions' stamp: 'AndyKellens 11/9/2011 16:25'!
growVersionArray
	versionArray := versionArray grownBy: self incrementSize.! !

!AbsintheEnvironment methodsFor: 'initialize-release' stamp: 'AndyKellens 11/9/2011 16:34'!
initialize
	super initialize.
	versionArray := Array new: self initialSize.
	currentPath := Dictionary new.! !

!AbsintheEnvironment methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:32'!
referenceVersion
	|ver|
	ver := versionArray at: variableRollbackIndex.
	^ver.! !

!AbsintheEnvironment methodsFor: 'paths' stamp: 'AndyKellens 11/9/2011 16:34'!
setCurrentPath: aPath
	currentPath at: variableIndex put: aPath.
	^true! !

!AbsintheEnvironment methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:32'!
setReferenceVersion: aVersion
	self setVersion:aVersion.
	^true! !

!AbsintheEnvironment methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:32'!
setVersion: aVersion
	variableIndex > versionArray size ifTrue:[ self growVersionArray].
	versionArray at: variableIndex put: aVersion! !

!AbsintheEnvironment methodsFor: 'unification-transactions' stamp: 'AndyKellens 11/9/2011 16:39'!
startUnify: aNumber
	| result currentVersion thePath|
	result := super startUnify: aNumber.
	currentVersion :=  (result > versionArray size) ifTrue:[nil] ifFalse:[versionArray at: result].
	thePath := currentPath at: result ifAbsent:[nil].
	currentVersion isNil ifFalse:[self setVersion: currentVersion].
	thePath isNil ifFalse:[self setCurrentPath: thePath].
	^result! !

!CompoundTerm methodsFor: '*SOUL-Absinthe' stamp: 'AndyKellens 11/8/2011 11:28'!
unifyWithAnnotatedTerm: aTerm inEnv: anEnv myIndex: sourceIndex hisIndex: targetIndex inSource: inSource
	
	^(self term
		unifyWith: aTerm term
		inEnv: anEnv
		myIndex: sourceIndex
		hisIndex: targetIndex
		inSource: inSource)
		and:
			[self annotation
				unifyWith: aTerm annotation
				inEnv: anEnv
				myIndex: sourceIndex
				hisIndex: targetIndex
				inSource: inSource]! !

SMarkTimer subclass: #AbsintheTimer
	instanceVariableNames: 'totalTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheTimer methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/17/2012 15:30'!
start
	^self! !

!AbsintheTimer methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/17/2012 15:30'!
stop
	^self! !

!AbsintheTimer methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/17/2012 15:29'!
totalTime
	^totalTime! !

!AbsintheTimer methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/17/2012 15:29'!
totalTime: aNumber
	totalTime := aNumber! !

SMarkSuite subclass: #AbsintheBenchSuite
	instanceVariableNames: 'path logicRepository logicEvaluator lastResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheBenchSuite class methodsFor: 'defaults' stamp: 'ReinoutStevens 1/19/2012 11:22'!
defaultRunner
	^AbsintheRunner ! !

!AbsintheBenchSuite methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/20/2012 13:26'!
benchCochanging
	|query|
	query := 
		'?start isOldestVersion,
		 e(notSoManyOf([true]),
   			and(?classA isClass, ?classB isClass, not(?classA equals: ?classB), ?classA wasChanged, ?classB wasChanged),
   				manyOf(and(or(and(?classA wasChanged, ?classB wasChanged),
				 and(not(?classA wasChanged), not(?classB wasChanged))))))
			matches:
		graph(versionTrans, ?start, ?end, <?classA, ?classB>, ?path)'.
	^self evalQuery: query withAssociations: (self pathAssociations).! !

!AbsintheBenchSuite methodsFor: 'running' stamp: 'ReinoutStevens 1/17/2012 14:18'!
evalQuery: aString withAssociations: aCollection
	|tree|
	tree := SoulFactory current makeParser parse: 'if ', aString.
	^(logicEvaluator evalQuery: tree in: logicRepository withAssociations: aCollection) allResults.
	! !

!AbsintheBenchSuite methodsFor: 'running' stamp: 'ReinoutStevens 1/17/2012 14:22'!
initializePath
	|result pathResults|
	result := self evalQuery: '?problemSize equals: ', self problemSize asString, ',?oldest isOldestVersion, ?path isPathStartingFrom: ?oldest withLength: ?problemSize' withAssociations: #().
	pathResults := result resultsForVariableNamed: 'path'.
	path := pathResults at: 1.! !

!AbsintheBenchSuite methodsFor: 'running' stamp: 'ReinoutStevens 1/17/2012 14:37'!
pathAssociations
	^OrderedCollection with: (#path -> path)! !

!AbsintheBenchSuite methodsFor: 'as yet unclassified' stamp: 'ReinoutStevens 1/19/2012 11:27'!
processResult: aResult withTimer: anAbsintheTimer
	anAbsintheTimer totalTime: (aResult timeTaken)! !

!AbsintheBenchSuite methodsFor: 'running' stamp: 'ReinoutStevens 1/19/2012 11:27'!
setUp
	logicRepository := SoulFactory repository: #Absinthe.
	logicEvaluator := AbsintheEvaluator.
	self initializePath.! !

LogicStorage subclass: #AbsintheModelReification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:25'!
callsMethodXM2

?method callsMethod: ?callee : ?version if 
	?version isReferenceVersion,?invocation isInvocationOfMethod: ?method : ?version,?callee isCandidateReceiverOfInvocation: ?invocation : ?version! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/8/2011 12:52'!
classInHierarchyOfXM2

?class classInHierarchyOf: ?super : ?version if 
	?version isReferenceVersion,?class isSubclassOf: ?super : ?version.

?class classInHierarchyOf: ?super : ?version if 
	?version isReferenceVersion,?intermediate isSubclassOf: ?super : ?version,?class classInHierarchyOf: ?intermediate.

?class classInHierarchyOf: ?class : ?version if 
	?version isReferenceVersion,?class isClass : ?version! !

!AbsintheModelReification methodsFor: 'accesses' stamp: 'AndyKellens 11/9/2011 16:03'!
isAccessorOfAccessXM2

?method isAccessorOfAccess: ?access : ?version if 
	?version isReferenceVersion,?access isVariableAccess : ?version,?accessVersion versionOfEntity: ?access : ?version,?method equals: [?access accessor]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:50'!
isAuthorOfVersionXM2

?author isAuthorOfVersion: ?version if 
	?version isVersion,equals(?author,[?version author])! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 12:55'!
isBaseClassOfXM2

?class isBaseClassOf: ?meta : ?version if 
	?meta isMetaClass : ?version,?class equals: [?meta theNonMetaClass]! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:22'!
isCandidateReceiverOfInvocationXM2

?method isCandidateReceiverOfInvocation: ?invocation : ?version if 
	?version isReferenceVersion,?invocation isInvocation : ?version,?invocationVersion versionOfEntity: ?invocation : ?version,member(?method,[?invocationVersion candidates])! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 15:04'!
isClassInPackageXM2

?class isClassInPackage: ?package : ?version if 
	?version isReferenceVersion,?package isPackage : ?version,?packageVersion versionOfEntity: ?package : ?version,member(?class,[?packageVersion classes]),?class isClass! !

!AbsintheModelReification methodsFor: 'variables' stamp: 'AndyKellens 11/9/2011 15:11'!
isClassInstanceVariableM1

+?entity isClassInstanceVariable : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGClassInstanceVariableHistory],?entityVersion versionOfEntity: ?entity : ?version,[?entityVersion notNil].

-?entity isClassInstanceVariable : ?version if 
	?version isReferenceVersion,?class isMetaclass : ?version,?entity isClassInstanceVariableOfMetaClass: ?class : ?version! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 15:11'!
isClassInstanceVariableOfMetaClassXM2

-?variable isClassInstanceVariableOfMetaClass: ?class : ?version if 
	?version isReferenceVersion,?class isMetaClass : ?version,?classVersion versionOfEntity: ?class : ?version,member(?variable,[?class instanceVariables]).

+?variable isClassInstanceVariableOfMetaClass: ?class : ?version if 
	?version isReferenceVersion,?variable isClassInstanceVariable : ?version,?class equals: [?variable parent]! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 15:26'!
isClassM1

+?entity isClass : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGClassHistory],?classVersion versionOfEntity: ?entity : ?version,[?classVersion notNil].

-?entity isClass : ?version if 
	?version isReferenceVersion,member(?entity,[?version classes])! !

!AbsintheModelReification methodsFor: 'variables' stamp: 'AndyKellens 11/9/2011 14:46'!
isClassVariableM1

+?entity isClassVariable : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGClassVariableHistory],?entityVersion versionOfEntity: ?entity : ?version,[?entityVersion notNil].

-?entity isClassVariable : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?entity isClassVariableOfClass: ?class : ?version! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 14:47'!
isClassVariableOfClassXM2

-?variable isClassVariableOfClass: ?class : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?classVersion versionOfEntity: ?class : ?version,member(?variable,[?class classVariables]).

+?variable isClassVariableOfClass: ?class : ?version if 
	?version isReferenceVersion,?variable isClassVariable : ?version,?class equals: [?variable parent]! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 13:59'!
isClassWithNameXM2

?class isClassWithName: ?name : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?classVersion versionOfEntity: ?class : ?version,?name equals: [?classVersion name]! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 14:00'!
isClassWithNameXinPackageXM3

?class isClassWithName: +?name inPackage: ?package : ?version if 
	?version isReferenceVersion,?package isPackage : ?version,?packageVersion versionOfEntity: ?package : ?version,?class equals: [?packageVersion classNamed: (?name asString)],[?class notNil].

?class isClassWithName: -?name inPackage: ?package : ?version if 
	?version isReferenceVersion,?class isClassInPackage: ?package : ?version,?class isClassWithName: ?name : ?version! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:01'!
isExtensionMethodInPackageXM2

-?method isExtensionMethodInPackage: ?package : ?version if 
	?package isPackage : ?version,?packageVersion versionOfEntity: ?package : ?version,member(?method,[?packageVersion extensionMethods]).

+?method isExtensionMethodInPackage: ?package : ?version if 
	?method isExtensionMethod : ?version,?methodVersion versionOfEntity: ?method : ?version,?package equals: [?methodVersion package]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:01'!
isExtensionMethodM1

?method isExtensionMethod : ?version if 
	?method isMethod : ?version,?methodVersion versionOfEntity: ?method : ?version,[?methodVersion isExtension]! !

!AbsintheModelReification methodsFor: 'variables' stamp: 'AndyKellens 11/9/2011 14:44'!
isInstanceVariableM1

+?entity isInstanceVariable : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGInstanceVariableHistory],?entityVersion versionOfEntity: ?entity : ?version,[?entityVersion notNil].

-?entity isInstanceVariable : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?entity isInstanceVariableOfClass: ?class : ?version! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 14:45'!
isInstanceVariableOfClassXM2

-?variable isInstanceVariableOfClass: ?class : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?classVersion versionOfEntity: ?class : ?version,member(?variable,[?class instanceVariables]).

+?variable isInstanceVariableOfClass: ?class : ?version if 
	?version isReferenceVersion,?variable isInstanceVariable : ?version,?class equals: [?variable parent]! !

!AbsintheModelReification methodsFor: 'variables' stamp: 'AndyKellens 11/9/2011 15:22'!
isInstanceVariableWithNameXinClassXM3

?variable isInstanceVariableWithName: -?name inClass: ?class : ?version if 
	?version isReferenceVersion,?variable isInstanceVariableOfClass: ?class : ?version,?variable isVariableWithName: ?name : ?version.

?variable isInstanceVariableWithName: +?name inClass: ?class : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?classVersion versionOfEntity: ?class : ?version,?variable equals: [?class instVarNamed:(?name asString)],[?variable notNil]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'ReinoutStevens 1/18/2012 10:55'!
isIntroducedM1

?entity isIntroduced : ?version if 
	?version isVersion,?version equals: [ ?entity firstVersion ]! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:11'!
isInvocationM1

+?entity isInvocation : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGInvocationHistory],?versionEntity versionOfEntity: ?entity : ?version,[?versionEntity notNil].

-?entity isInvocation : ?version if 
	?version isReferenceVersion,?entity isInvocationOfMethod: ?method : ?version! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:11'!
isInvocationOfMethodXM2

?invocation isInvocationOfMethod: ?method : ?version if 
	?version isReferenceVersion,?method isMethod : ?version,?methodVersion versionOfEntity: ?method : ?version,member(?invocation,[?methodVersion invocations])! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:15'!
isMessageOfInvocationXM2

?message isMessageOfInvocation: ?invocation : ?version if 
	?version isReferenceVersion,?invocation isInvocation : ?version,?invocationVersion versionOfEntity: ?invocation : ?version,?message equals: [?invocationVersion message]! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 14:00'!
isMetaClassM1

+?entity isMetaClass : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGMetaclassHistory],?classVersion versionOfEntity: ?entity : ?version,[?classVersion notNil].

-?entity isMetaClass : ?version if 
	?class isClass : ?version,?entity isMetaClassOf: ?class! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 12:53'!
isMetaClassOfXM2

?meta isMetaClassOf: ?class : ?version if 
	?class isClass : ?version,?meta equals: [?class theMetaClass]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:02'!
isMethodInClassXM2

-?method isMethodInClass: ?class : ?version if 
	?version isReferenceVersion,or(?class isClass : ?version,?class isMetaClass : ?version),?classVersion versionOfEntity: ?class : ?version,member(?method,[?classVersion methods]).

+?method isMethodInClass: ?class : ?version if 
	?version isReferenceVersion,?methodVersion equals: [?version thisHistory: ?method],[?methodVersion notNil],?class equals: [?method parent]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 16:07'!
isMethodM1

+?entity isMethod : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGMethodHistory],?methodVersion versionOfEntity: ?entity : ?version,[?methodVersion notNil].

-?entity isMethod : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?entity isMethodInClass: ?class.

-?entity isMethod : ?version if 
	?version isReferenceVersion,?class isMetaClass : ?version,?entity isMethodInClass: ?class! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 13:55'!
isMethodWithNameXM2

?method isMethodWithName: ?name : ?version if 
	?version isReferenceVersion,?method isMethod : ?version,?name equals: [?method name]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 14:03'!
isMethodWithNameXinClassXM3

?method isMethodWithName: +?name inClass: ?class : ?version if 
	?version isReferenceVersion,?class isClass : ?version,?classVersion versionOfEntity: ?class : ?version,?entity equals: [?classVersion methodNamed: (?name asString)],[?entity notNil].

?method isMethodWithName: -?name inClass: ?class : ?version if 
	?version isReferenceVersion,?method isMethodInClass: ?class : ?version,?method isMethodWithName: ?name : ?version! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'ReinoutStevens 11/15/2011 14:41'!
isMostRecentVersionM1

?entity isMostRecentVersion if 
	equals(?entity,[MLI forEvolution mostRecentVersion]),?entity setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:53'!
isNextVersionOfXM2

-?next isNextVersionOf: ?prev if 
	?prev isVersion,member(?next,[?prev successors]),?next setAsReferenceVersion.

+?next isNextVersionOf: ?prev if 
	?next isVersion,member(?prev,[?next predecessors]),[?prev isNilHistory not],?next setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'ReinoutStevens 11/15/2011 14:41'!
isOldestVersionM1

?entity isOldestVersion if 
	equals(?entity,[MLI forEvolution oldestVersion]),?entity setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'packages' stamp: 'AndyKellens 11/8/2011 12:50'!
isPackageM1

-?package isPackage : ?version if 
	?version isReferenceVersion,member(?package,[?version packages]).

+?package isPackage : ?version if 
	?version isReferenceVersion,[?package isKindOf: RGPackageHistory],[(?version thisHistory: ?package) notNil]! !

!AbsintheModelReification methodsFor: 'packages' stamp: 'AndyKellens 11/8/2011 13:03'!
isPackageWithNameXM2

-?package isPackageWithName: +?name : ?version if 
	!!,?version isReferenceVersion,equals(?package,[?version packageNamed: (?name asString)]),[?package notNil].

?package isPackageWithName: ?name : ?version if 
	?package isPackage : ?version,?packageVersion versionOfEntity: ?package : ?version,equals(?name,[?package name])! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:50'!
isPredecessorOfXM2

?version isPredecessorOf: ?successor if 
	?successor isVersion,?version isVersion,?successor isSuccessorOf: ?version,?version setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:54'!
isPreviousVersionOfXM2

-?prev isPreviousVersionOf: ?next if 
	?next isVersion,member(?prev,[?next predecessors]),[?prev isNilHistory not],?prev setAsReferenceVersion.

+?prev isPreviousVersionOf: ?next if 
	?prev isVersion,member(?next,[?prev successors]),?next setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'references' stamp: 'AndyKellens 11/9/2011 16:11'!
isReferenceM1

+?entity isReference : ?version if 
	?version isReferenceVersion,[?entity isKindOf: RGReferenceHistory],?versionEntity versionOfEntity: ?entity : ?version,[?versionEntity notNil].

-?entity isReference : ?version if 
	?version isReferenceVersion,?entity isReferenceOfMethod: ?method : ?version! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 16:10'!
isReferenceOfMethodXM2

?reference isReferenceOfMethod: ?method : ?version if 
	?version isReferenceVersion,?method isMethod : ?version,?methodVersion versionOfEntity: ?method : ?version,member(?reference,[?methodVersion references])! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:49'!
isReferenceVersionM1

?version isReferenceVersion if 
	getEnv(?env,?),equals(?version,[?env referenceVersion]),[?version isNil not]! !

!AbsintheModelReification methodsFor: 'references' stamp: 'AndyKellens 11/9/2011 16:15'!
isReferrerOfReferenceXM2

?method isReferrerOfReference: ?reference : ?version if 
	?version isReferenceVersion,?reference isReference : ?version,?referenceVersion versionOfEntity: ?reference : ?version,?method equals: [?reference source]! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:12'!
isSelfInvocationM1

?entity isSelfInvocation : ?version if 
	?version isReferenceVersion,?entity isInvocation : ?version,[?entity isSelf]! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:16'!
isSenderOfInvocationXM2

?method isSenderOfInvocation: ?invocation : ?version if 
	?version isReferenceVersion,?invocation isInvocation : ?version,?invocationVersion versionOfEntity: ?invocation : ?version,?method equals: [?invocationVersion sender]! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:13'!
isStaticInvocationM1

?entity isStaticInvocation : ?version if 
	?version isReferenceVersion,?entity isInvocation : ?version,[?entity isStatic]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 13:12'!
isStaticMethodM1

?method isStaticMethod : ?version if 
	?method isMethod : ?version,?method isMethodInClass: ?class : ?version,?class isMetaClass : ?version! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 13:40'!
isSubclassOfXM2

?sub isSubclassOf: +?super : ?version if 
	?version isReferenceVersion,?super isClass : ?version,member(?sub,[?super subclasses]).

?sub isSubclassOf: -?super : ?version if 
	?version isReferenceVersion,?sub isClass : ?version,?super isSuperclassOf: ?sub.

?sub isSubclassOf: +?super : ?version if 
	?version isReferenceVersion,?super isMetaClass : ?version,?base isBaseClassOf: ?super : ?version,?baseSub isSubclassOf: ?base : ?version,?sub isMetaClassOf: ?baseSub : ?version.

?sub isSubclassOf: -?super : ?version if 
	?version isReferenceVersion,?sub isMetaClass : ?version,?super isSuperclassOf: ?sub! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:50'!
isSuccessorOfXM2

?successor isSuccessorOf: ?version if 
	?version isVersion,?successor isVersion,[?successor isSuccessorOf: ?version],?successor setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:13'!
isSuperInvocationM1

?entity isSuperInvocation : ?version if 
	?version isReferenceVersion,?entity isInvocation : ?version,[?entity isSuper]! !

!AbsintheModelReification methodsFor: 'classes' stamp: 'AndyKellens 11/9/2011 13:54'!
isSuperclassOfXM2

?super isSuperclassOf: +?sub : ?version if 
	?version isReferenceVersion,?sub isClass : ?version,?super equals: [?sub superclass].

?super isSuperclassOf: -?sub : ?version if 
	?version isReferenceVersion,?super isClass : ?version,?sub isSubclassOf: ?super : ?version.

?super isSuperclassOf: -?sub : ?version if 
	?version isReferenceVersion,?super isMetaClass : ?version,?sub isSubclassOf: ?super : ?version.

?super isSuperclassOf: +?sub : ?version if 
	?version isReferenceVersion,?sub isMetaClass : ?version,?baseSub isBaseClassOf: ?sub : ?version,?baseSuper equals: [?baseSub superclass],?super isMetaClassOf: ?baseSuper! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:52'!
isTimestampOfVersionXM2

?time isTimestampOfVersion: ?version if 
	?version isVersion,equals(?time,[?version timeStamp])! !

!AbsintheModelReification methodsFor: 'invocations' stamp: 'AndyKellens 11/9/2011 14:13'!
isUnknownInvocationM1

?entity isUnknownInvocation : ?version if 
	?version isReferenceVersion,?entity isInvocation : ?version,[?entity isUnknown]! !

!AbsintheModelReification methodsFor: 'accesses' stamp: 'AndyKellens 11/9/2011 15:30'!
isVariableAccessM1

+?entity isVariableAccess : ?version if 
	[?entity isKindOf: RGAccessHistory],?versionEntity versionOfEntity: ?entity : ?version,[?versionEntity notNil].

-?entity isVariableAccess : ?version if 
	?version isReferenceVersion,?method isMethod : ?version,?entity isVariableAccessOfMethod: ?method : ?version! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 15:28'!
isVariableAccessOfMethodXM2

?access isVariableAccessOfMethod: ?method : ?version if 
	?version isReferenceVersion,?method isMethod : ?version,?methodVersion versionOfEntity: ?method : ?version,member(?access,[?methodVersion accesses])! !

!AbsintheModelReification methodsFor: 'variables' stamp: 'AndyKellens 11/9/2011 15:14'!
isVariableWithNameXM2

?variable isVariableWithName: ?name : ?version if 
	?version isReferenceVersion,or(?variable isInstanceVariable : ?version,?variable isClassVariable : ?version,?variable isClassInstanceVariable : ?version),?name equals: [?variable name]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'ReinoutStevens 11/15/2011 14:37'!
isVersionM1

+?entity isVersion if 
	[?entity isKindOf: RGRepositorySnapshot].

-?entity isVersion if 
	member(?entity,[MLI forEvolution versions]),?entity setAsReferenceVersion! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:49'!
originM0

origin : ?version if 
	?version isVersion,not(? isPreviousVersionOf: ?version)! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 16:05'!
readsVariableXM2

?method readsVariable: ?variable : ?version if 
	?version isReferenceVersion,?access isVariableAccessOfMethod: ?method : ?version,?access variableAccessIsRead : ?version,?access variableAccessAccesses: ?variable : ?version! !

!AbsintheModelReification methodsFor: 'references' stamp: 'AndyKellens 11/9/2011 16:12'!
referenceRefersToClassXM2

?reference referenceRefersToClass: ?class : ?version if 
	?version isReferenceVersion,?reference isReference : ?version,?referenceVersion versionOfEntity: ?reference : ?version,?class equals: [?reference target]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 16:16'!
refersToClassXM2

?method refersToClass: ?class : ?version if 
	?version isReferenceVersion,?reference isReferenceOfMethod: ?method : ?version,?reference referenceRefersToClass: ?class : ?version! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:46'!
setAsReferenceVersionM1

?version setAsReferenceVersion if 
	getEnv(?env,?),[?env setReferenceVersion: ?version]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 11:50'!
terminalM0

terminal : ?version if 
	?version isVersion,not(? isNextVersionOf: ?version)! !

!AbsintheModelReification methodsFor: 'accesses' stamp: 'AndyKellens 11/9/2011 15:53'!
variableAccessAccessesXM2

?access variableAccessAccesses: ?variable : ?version if 
	?version isReferenceVersion,?access isVariableAccess : ?version,?accessVersion versionOfEntity: ?access : ?version,?variable equals: [?access variable]! !

!AbsintheModelReification methodsFor: 'accesses' stamp: 'AndyKellens 11/9/2011 15:38'!
variableAccessIsReadM1

?access variableAccessIsRead : ?version if 
	?version isReferenceVersion,?access isVariableAccess : ?version,?accessVersion versionOfEntity: ?access : ?version,[?accessVersion isWrite not]! !

!AbsintheModelReification methodsFor: 'accesses' stamp: 'AndyKellens 11/9/2011 15:39'!
variableAccessIsWriteM1

?access variableAccessIsWrite : ?version if 
	?version isReferenceVersion,?access isVariableAccess : ?version,?accessVersion versionOfEntity: ?access : ?version,[?accessVersion isWrite]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'AndyKellens 11/8/2011 12:49'!
versionOfEntityXM2

?versionEntity versionOfEntity: ?entity : ?version if 
	?version isVersion,equals(?versionEntity,[?version thisHistory: ?entity]),[?versionEntity notNil]! !

!AbsintheModelReification methodsFor: 'versions' stamp: 'ReinoutStevens 11/15/2011 13:52'!
wasChangedM1

?entity wasChanged : ?version if 
	?version isReferenceVersion,?entityVersion versionOfEntity: ?entity : ?version,[?entityVersion wasChanged]! !

!AbsintheModelReification methodsFor: 'methods' stamp: 'AndyKellens 11/9/2011 16:06'!
writesVariableXM2

?method writesVariable: ?variable : ?version if 
	?version isReferenceVersion,?access isVariableAccessOfMethod: ?method : ?version,?access variableAccessIsWrite : ?version,?access variableAccessAccesses: ?variable : ?version! !

LogicStorage subclass: #AbsintheTemporalReasoning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheTemporalReasoning methodsFor: 'paths' stamp: 'AndyKellens 11/9/2011 16:23'!
auxIsPathBetweenXandXM3

<?end> auxIsPathBetween: ?start and: ?end if 
	member(?end,[?start successors]).

<?start|?rest> auxIsPathBetween: ?start and: ?end if 
	member(?successor,[?start successors]),?rest auxIsPathBetween: ?successor and: ?end! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:27'!
finallyM1

finally(?term) : <> if 
	[false].

finally(?term) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?term.

finally(?term) : ?path if 
	?path isPath,?path equals: <?first|?rest>,finally(?term) : ?rest! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:27'!
globallyM1

globally(?term) : ?path if 
	?path isPath,?path equals: <>.

globally(?term) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?term,globally(?term) : ?rest! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:28'!
holdsOnAllPathsBetweenXandXM3

?term holdsOnAllPathsBetween: ?start and: ?end if 
	findall(?path,?path isPathBetween: ?start and: ?end,?paths),?term holdsOnAllPathsInList: ?paths! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:32'!
holdsOnAllPathsInListXM2

?term holdsOnAllPathsInList: <> if 
	[true].

?term holdsOnAllPathsInList: <?first|?rest> if 
	?first setAsCurrentPath,?term,?term holdsOnAllPathsInList: ?rest! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:28'!
holdsOnAllPathsStartingFromXM2

?term holdsOnAllPathsStartingFrom: ?start if 
	findall(?path,?path isPathStartingFrom: ?start,?paths),?term holdsOnAllPathsInList: ?paths! !

!AbsintheTemporalReasoning methodsFor: 'Auxiliary' stamp: 'AndyKellens 11/9/2011 16:46'!
isCurrentStateM1

?variable isCurrentState : ?version if 
	?variable equals: ?version! !

!AbsintheTemporalReasoning methodsFor: 'paths' stamp: 'AndyKellens 11/9/2011 16:22'!
isPathBetweenXandXM3

?path isPathBetween: ?start and: ?end if 
	?start isVersion,?end isVersion,[?end isSuccessorOf: ?start],?path auxIsPathBetween: ?start and: ?end! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:28'!
isPathBetweenXandXwhereXM4

?path isPathBetween: ?start and: ?end where: ?term if 
	?path isPathBetween: ?start and: ?end,?path setAsCurrentPath,?term! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:28'!
isPathM1

-?path isPath if 
	getEnv(?env,?),?path equals: [?env currentPath],[?path isNil not].

+?path isPath if 
	list(?path),?path setAsCurrentPath! !

!AbsintheTemporalReasoning methodsFor: 'paths' stamp: 'AndyKellens 11/9/2011 16:22'!
isPathStartingFromXM2

<?version> isPathStartingFrom: ?version if 
	?version isVersion,[?version successors isEmpty].

<?version|?rest> isPathStartingFrom: ?version if 
	?version isVersion,member(?successor,[?version successors]),?rest isPathStartingFrom: ?successor! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:28'!
isPathStartingFromXwhereXM3

?path isPathStartingFrom: ?start where: ?term if 
	?path isPathStartingFrom: ?start,?path setAsCurrentPath,?term! !

!AbsintheTemporalReasoning methodsFor: 'paths' stamp: 'ReinoutStevens 1/17/2012 13:19'!
isPathStartingFromXwithLengthXM3

?path isPathStartingFrom: ?start withLength: 0 if 
	!!,?path equals: <>.

<?start|?path> isPathStartingFrom: ?start withLength: ?aNumber if 
	[ ?aNumber > 0 ],?start isVersion,?succ isNextVersionOf: ?start,?path isPathStartingFrom: ?succ withLength: [?aNumber - 1]! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:29'!
nextM1

next(?term) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?rest setAsCurrentPath,?rest equals: <?second|?>,?second setAsReferenceVersion,?term,?first setAsReferenceVersion! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 15:54'!
propM2

prop(?version,?term) if 
	?version setAsReferenceVersion,?term! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:30'!
releaseM2

release(?term,?condition) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?condition,?term.

release(?term,?condition) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?term,release(?term,?condition) : ?rest.

release(?term,?condition) : ?path if 
	?path isPath,?path equals: <>! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 16:55'!
satEUntilM3

tabled satEUntil(?current,?left,?right) if 
	?right succeedsIn: ?current.

tabled satEUntil(?current,?left,?right) if 
	?left succeedsIn: ?current,trans(?current,?next),?next setAsReferenceVersion,satEUntil(?next,?left,?right)! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 16:57'!
satNotEGloballyBridgeM3

tabled satNotEGloballyBridge(?current,?next,?term) if 
	trans(?current,?next),not(satNotEGlobally(?next,?term))! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 16:56'!
satNotEGloballyM2

tabled satNotEGlobally(?current,?term) if 
	not(?term) succeedsIn: ?current.

tabled satNotEGlobally(?current,?term) if 
	?current isVersion,not(satNotEGloballyBridge(?current,?E2,?term))! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:32'!
setAsCurrentPathM1

?path setAsCurrentPath if 
	getEnv(?env,?),[?env setCurrentPath: ?path]! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 16:50'!
succeedsInXM2

[true] succeedsIn: ?current if 
	!!,?current setAsReferenceVersion.

[false] succeedsIn: ?current if 
	!!,?current isVersion,[ false ].

and(?left,?right) succeedsIn: ?current if 
	!!,?left succeedsIn: ?current,?right succeedsIn: ?current.

or(?left,?right) succeedsIn: ?current if 
	?left succeedsIn: ?current.

or(?left,?right) succeedsIn: ?current if 
	!!,?right succeedsIn: ?current.

eNext(?term) succeedsIn: ?current if 
	!!,trans(?current,?next),?term succeedsIn: ?next.

not(?term) succeedsIn: ?current if 
	!!,?current isVersion,not(?term succeedsIn: ?current).

aNext(?term) succeedsIn: ?current if 
	!!,?current isVersion,not(eNext(not(?term)) succeedsIn: ?current).

eUntil(?left,?right) succeedsIn: ?current if 
	!!,satEUntil(?current,?left,?right).

aUntil(?left,?right) succeedsIn: ?current if 
	!!,not(eUntil(not(?right),and(not(?left),not(?right)))) succeedsIn: ?current,satNotEGlobally(?current,not(?right)).

eFinally(?term) succeedsIn: ?current if 
	!!,eUntil([true],?term) succeedsIn: ?current.

aFinally(?term) succeedsIn: ?current if 
	!!,satNotEGlobally(?current,not(?term)).

eGlobally(?term) succeedsIn: ?current if 
	!!,?current isVersion,not(satNotEGlobally(?current,?term)).

aGlobally(?term) succeedsIn: ?current if 
	!!,?current isVersion,not(eFinally(not(?term))) succeedsIn: ?current.

"no primitive, so a normal property in a version"

?term succeedsIn: ?current if 
	prop(?current,?term)! !

!AbsintheTemporalReasoning methodsFor: 'CTL' stamp: 'ReinoutStevens 11/22/2011 16:57'!
transM2

trans(?current,?next) if 
	?current isVersion,?next isNextVersionOf: ?current! !

!AbsintheTemporalReasoning methodsFor: 'LTL' stamp: 'AndyKellens 11/9/2011 16:31'!
untilM2

until(?term,?condition) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?condition.

until(?term,?condition) : ?path if 
	?path isPath,?path equals: <?first|?rest>,?first setAsReferenceVersion,?term,until(?term,?condition) : ?rest.

until(?term,?condition) : <> if 
	[false]! !

!AbsintheTemporalReasoning methodsFor: 'Path Expressions' stamp: 'AndyKellens 11/9/2011 16:47'!
versionTransM3

versionTrans(?fromWorld,?toWorld,?toWorld) if 
	?fromWorld isVersion,?toWorld isNextVersionOf: ?fromWorld! !

AbstractTerm subclass: #AlwaysUnifies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AlwaysUnifies methodsFor: 'unification' stamp: 'AndyKellens 11/8/2011 11:16'!
unifyWith: aTerm inEnv: anEnv myIndex: myIndex hisIndex: hisIndex inSource: inSource
	^true! !

StandardSoulFactory subclass: #AbsintheFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheFactory class methodsFor: 'setup' stamp: 'AndyKellens 11/9/2011 16:19'!
createAbsintheRepository
	
	| rep |
	rep := SoulFactory current makeRepository new.
	rep loadLayer: AbsintheModelReification.
	rep loadLayer: AbsintheTemporalReasoning.
	LogicPrimitives allSubclasses do: [:cl | rep loadLayer: cl].
	SoulFactory repository: #Absinthe put: rep! !

!AbsintheFactory methodsFor: 'annotated terms' stamp: 'AndyKellens 11/8/2011 11:36'!
defaultAnnotation
	^AlwaysUnifies new! !

!AbsintheFactory methodsFor: 'evaluators' stamp: 'AndyKellens 11/8/2011 11:45'!
evaluatorForLogicQuery 
	^AbsintheEvaluator! !

!AbsintheFactory methodsFor: 'terms' stamp: 'AndyKellens 11/8/2011 11:37'!
makeAnnotatedTerm
	^AbsintheAnnotatedTerm! !

!AbsintheFactory methodsFor: 'kernel' stamp: 'AndyKellens 11/8/2011 11:36'!
makeEnvironment
	^AbsintheEnvironment 
! !

!AbsintheFactory methodsFor: 'kernel' stamp: 'AndyKellens 11/8/2011 11:36'!
makeResolver
	^AbsintheResolver! !

Resolver subclass: #AbsintheResolver
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-Absinthe'!

!AbsintheResolver methodsFor: 'accessing' stamp: 'AndyKellens 11/8/2011 11:37'!
clause: aClause
	clause := aClause! !

!AbsintheResolver methodsFor: 'access' stamp: 'AndyKellens 11/8/2011 11:37'!
nextResolution

	| result currentHornClause targetSource hisIndex |
	
	[result isNil & (clauseIndex <= delayedClauses size)] whileTrue: 
			[
			currentHornClause := delayedClauses at: clauseIndex.
			clauseIndex := clauseIndex + 1.
			targetSource := currentHornClause conclusion.
			hisIndex := env startUnifyWith: currentHornClause.
			((clause
				unifyWith: targetSource 
				inEnv: env
				myIndex: startIndex
				hisIndex: hisIndex
				inSource: true))
				ifTrue: 
					[result := ResolutionResult
								condition: currentHornClause condition
								rollbackInfo: env rollbackInfo
								conditionsEnvIndex: hisIndex
								cutState: currentHornClause containsCut]
				ifFalse: [env rollback]].
	^result! !

!AbsintheResolver methodsFor: 'accessing' stamp: 'AndyKellens 11/8/2011 11:37'!
version: aVersion
	version := aVersion! !
